/*  The iNiQUiTY Bulletin Board System
    (C) Copyright 1994, Mike Fricker
    Release Version: 1.00a23
    Preliminary alpha testing version

    iNiQUiTY's Data Structures

    Ported To C/C++ By Chris Bowlby

    Note:  All Variables have their original forms, and types, only their
	   appearence may have changed due to the differences in Pascal and
	   C.
*/

#define bbsTitle        "Iniquity"
#define bbsVersion      "1.00a23"
#define bbsVerLong      "1.00 alpha 23"
#define bbsRelease      "09/17/95"

#define maxAddress      10
#define maxArchiver     16
#define maxBatch        20
#define maxColor        11
#define maxConf         50
#define maxDescLen      51
#define maxDescLns      100
#define maxEmail        2000
#define maxEvent        25
#define maxFileArea     256
#define maxFiles        2000
#define maxMenuCmd      50
#define maxMenuStack    12
#define maxMsgArea      256
#define maxMsgLines     200
#define maxNode         30
#define maxOrigin       20
#define maxOvrSize      60000
#define maxPos          30
#define maxProt         26
#define maxRepeatBuf    4096
#define maxSigLines     6
#define maxStatBar      6
#define maxStrings      255
#define maxTetris       30
#define maxTextLib      100
#define maxUsers        6000

#define colError        0
#define colText         1
#define colTextLo       2
#define colTextHi       3
#define colInfo         4
#define colInfoLo       5
#define colInfoHi       6
#define colItem         7
#define colItemSel      8
#define colBorder       9
#define colEdit         10

typedef unsigned char tACString[21];

typedef unsigned char tStrings[maxStrings][256];

typedef struct {
	char ComPort;
	long int BaudRate;
	char Parity;
	unsigned char StopBits;
	unsigned char DataBits;
	unsigned char LockedPort;
	unsigned char MultiRing;
	unsigned char irqNumber;
	char irqString[5];

	char sInit1[46];
	char sInit2[46];
	char sInit3[46];
	char sExitStr[46];
	char sAnswer[46];
	char sHangup[46];
	char sOffhook[46];
	char sDialPrefix[46];

	char rError[46];
	char rNoCarrier[46];
	char rOK[46];
	char rRing[46];
	char rBusy[46];

	char c300[46];
	char c1200[46];
	char c1275[46];
	char c2400[46];
	char c4800[46];
	char c7200[46];
	char c9600[46];
	char c12000[46];
	char c14400[46];
	char c16800[46];
	char c19200[46];
	char c21600[46];
	char c24000[46];
	char c26400[46];
	char c28800[46];
	char c38400[46];
	char c57600[46];
	char c64000[46];
	char c115200[46];

	char Reserved[1024];
} tModemRec;

typedef struct {
	unsigned char Fore;
	unsigned char Back;
	unsigned char Blink;
} tColorRec;

tColorRec tColor[maxColor];

typedef struct {
	unsigned int Zone;
	unsigned int Net;
	unsigned int Node;
	unsigned int Point;
} tNetAddressRec;

typedef unsigned char tMacros[10][256];

typedef struct {
	char bbsName[41];
	char bbsPhone[14];
	char SysOpAlias[37];
	char SysOpName[37];
	char SystemPW[21];
	tACString acsSysOp;
	tACString acsCoSysOp;
	unsigned char DirectWrites;
	unsigned char SnowChecking;
	unsigned char OverlayToEMS;
	unsigned char RealNameSystem;
	unsigned char ShowPwLocal;

	unsigned char StatOnDefault;
	unsigned char StatBarOn;
	unsigned char StatType;
	unsigned char StatBar;
	unsigned char StatLo;
	unsigned char StatTxt;
	unsigned char StatHi;

	tColorRec DefaultCol[maxColor];

	tNetAddressRec Address[maxAddress];

	unsigned char ESCtoExit;
	unsigned char OffhookLocal;
	unsigned char VgaEffects;
	unsigned char ScreenSaver;
	unsigned int BlankSeconds;
	unsigned char DefWFCstat;

	char pathData[41];
	char pathText[41];
	char pathMenu[41];
	char pathMsgs[41];
	char pathSwap[41];
	char pathDoor[41];
	char pathProt[41];
	char pathTemp[41];
	char pathDnld[41];
	char pathLogs[41];

	unsigned char NoBBSlogging;
	unsigned char LogLineChat;
	unsigned char LogSplitChat;
	unsigned char LogMicroDOS;

	unsigned char SwapInShell;
	unsigned char SwapToEMS;
	unsigned char ProtocolSwap;

	char BbsAccessPw[21];
	char NoBaudPW[21];
	unsigned char SysOpAutoLogin;
	unsigned char MatrixLogin;
	unsigned char AskApply;
	unsigned char TimeLimitPerCall;
	tACString acsSystemPWLogin;
	unsigned char CallsBirth;
	unsigned char CallsPhone;
	unsigned char LoginTrys;

	char Origin[maxOrigin][76];

	char NoChatPW[21];
	unsigned char ChatPagenoise;
	unsigned char maxPageTimes;
	unsigned char maxPageBeeps;

	char PwEchoChar;
	unsigned char RemovePause;
	unsigned char AddLocalCalls;
	unsigned char numLastCalls;

	tACString acsPostEmail;
	tACString acsAnonymous;
	tACString acsAnonAutoMsg;
	tACString acsUploadMessage;
	tACString acsAutoSigUse;
	unsigned char AbortMandOk;
	unsigned char AskPrivateMsg;
	unsigned char AskPrivateReply;
	unsigned char AskPostInArea;
	unsigned char AskUploadReply;
	unsigned char AskUploadEmail;
	unsigned char AskKillMsg;
	unsigned char AskKillAllMsg;

	char NewUserPW[21];
	unsigned char AliasFormat;
	unsigned char DefaultPageLen;
	unsigned char NewExpert;
	unsigned char NewYesNoBars;
	unsigned char NewHotKeys;
	unsigned char NewAskExpert;
	unsigned char NewAskYesNoBars;
	unsigned char NewAskHotKeys;
	unsigned char NewAskPagelen;
	char StartMenu[9];

	tMacros Macro;

	char pathArch[41];
	unsigned char ArchiverSwap;
	unsigned char NewPause;
	unsigned char NewQuote;
	unsigned char NewAskPause;
	unsigned char NewAskQuote;
	unsigned char AskAutoQuote;
	unsigned char DefaultQuoteNum;
	unsigned char MaxQuoteLines;

	unsigned char iniqAsDoor;
	char pathAtch[41];
	tACString acsAttachPublic;
	tACString acsAttachEmail;
	unsigned char confIgnoreMsg;
	unsigned char compMsgAreas;
	unsigned char compFileAreas;
	unsigned char RestoreChatTime;
	unsigned int kbPerFilePoint;
	unsigned char useFilePoints;
	unsigned char importDescs;
	unsigned char useDLlimit;
	unsigned char useDLkbLimit;
	char bbsLocation[41];
	char qwkFilename[9];
	char qwkWelcome[13];
	char qwkNews[13];
	char qwkGoodbye[13];
	char qwkLocalPath[41];
	unsigned char qwkIgnoreTime;
	unsigned char qwkStripSigs;
	char noDescLine[51];
	unsigned int WaitConnect;
	unsigned int modemReInit;
	unsigned char lightChar;
	unsigned char lightCharOk;
	unsigned char lightCharFail;
	char virusScan[51];
	unsigned char virusOk;
	unsigned char maxFileAge;
	unsigned char strictAge;
	char delFile[13];
	char addFile[13];
	char comFile[13];
	unsigned char extMaint;
	unsigned char ulsearch;
	unsigned char autoValidate;
	unsigned int filePtsPer;
	unsigned char useUlDlratio;
	unsigned char useKbRatio;

	char fileDesc1[14];
	char fileDesc2[14];
	unsigned char useTextLibs;
	char pathLibs[41];
	unsigned char echomailLev;

	unsigned char newConfig;
	unsigned char newVerify;

	char pmtYes[31];
	char pmtNo[31];
	char pmtYesWord[21];
	char pmtnoWord[21];
	char pmtYesBar[31];
	char pmtNoBar[31];

	unsigned char descWrap;
	char chatStart[6];
	char chatEnd[6];
	tACString chatOverAcs;
	unsigned char advFileBar;
	unsigned char inactTime;
	unsigned char inactInChat;
	unsigned int inactSeconds;
	unsigned int inactWarning;
	char ansiString[76];
	unsigned char pageAskEmail;

	unsigned char Reserved[4059];
} tCfgRec;

typedef struct {
 unsigned int acAnsi     : 1;
 unsigned int acAvatar   : 1;
 unsigned int acRip      : 1;
 unsigned int acYesNoBar : 1;
 unsigned int acDeleted  : 1;
 unsigned int acExpert   : 1;
 unsigned int acHotKey   : 1;
 unsigned int acPause    : 1;
 unsigned int acQuote    : 1;
} tUserACflag;

typedef struct {
	unsigned char scnMsg;
	long int ptrMsg;
} tScanRec;

typedef char tAutoSig[maxSigLines][81];

typedef char tUserFlags[26];

typedef struct {
	int Number;
	char UserName[37];
	char RealName[37];
	char Password[21];
	char PhoneNum[14];
	char BirthDate[9];
	char Location[41];
	char Address[37];
	char UserNote[41];
	char sex;
	unsigned char SL;
	unsigned char DSL;
	long int BaudRate;
	unsigned int TotalCalls;
	unsigned int curMsgArea;
	unsigned int curFileArea;
	tUserACflag acFlag;
	tColorRec Color[maxColor];
	char LastCall[9];
	unsigned int PageLength;
	unsigned int EmailWaiting;
	char Level;
	unsigned int timeToday;
	unsigned int timePerDay;
	unsigned char AutoSigLns;
	tAutoSig AutoSig;
	unsigned char confMsg;
	unsigned char confFile;

	char FirstCall[9];
	char StartMenu[9];
	char fileScan[9];
	char SysOpNote[41];
	unsigned int Posts;
	unsigned int Email;
	unsigned int Uploads;
	unsigned int Downloads;
	unsigned int UploadKb;
	unsigned int DownloadKb;
	unsigned int CallsToday;
	tUserFlags Flag;
	unsigned int filePts;
	unsigned int postCall;
	unsigned int limitDL;
	unsigned int limitDLkb;
	unsigned int todayDL;
	unsigned int todayDLkb;
	long int lastQwkDate;
	unsigned int uldlRatio;
	unsigned int kbRatio;
	unsigned char textLib;
	char zipCode[11];

	unsigned char Reserved[382];
} tUserRec;

typedef struct {
	unsigned char mType;
	char MenuName[256];
	char PromptName[61];
	char HelpFile[9];
	char Prompt[256];
	tACString Acs;
	char Password[21];
	char Fallback[9];
	unsigned char Expert;
	unsigned char GenColumns;
	unsigned char HotKey;
	unsigned char ClearBefore;
	unsigned char CenterTtl;
	unsigned char ShowPrompt;
	unsigned char PauseBefore;
	unsigned char GlobalUse;
	unsigned char InputUp;

	char Reserved[100];
} tMenuRec;

typedef struct {
	char Desc[36];
	char Help[71];
	char Keys[15];
	tACString ACS;
	char Command[3];
	char Param[71];
	unsigned char Hidden;
} tCommandRec;

tCommandRec tCommands[maxMenuCmd];

typedef struct {
 unsigned int msgDeleted         : 1;
 unsigned int msgSent            : 1;
 unsigned int msgAnonymous       : 1;
 unsigned int msgEchoMail        : 1;
 unsigned int msgPrivate         : 1;
 unsigned int msgForwarded       : 1;
} tMsgStatusFlag;

typedef struct {
 unsigned int nPrivate              : 1;
 unsigned int nCrash                : 1;
 unsigned int nReceived             : 1;
 unsigned int nSent                 : 1;
 unsigned int nFileAttached         : 1;
 unsigned int nInTransit            : 1;
 unsigned int nOrphan               : 1;
 unsigned int nKillSent             : 1;
 unsigned int nLocal                : 1;
 unsigned int nHold                 : 1;
 unsigned int nUnused               : 1;
 unsigned int nFileRequest          : 1;
 unsigned int nReturnReceiptRequest : 1;
 unsigned int nIsReturnReceipt      : 1;
 unsigned int nAuditRequest         : 1;
 unsigned int nFileUpdateRequest    : 1;
} tNetAttribFlag;

typedef struct {
	unsigned int UserNum;
	char Alias[37];
	char Realname[37];
	char Name[37];
	char UserNote[41];
	tNetAddressRec Address;
} tMsgInfoRec;

struct {
	tMsgInfoRec FromInfo;
	tMsgInfoRec ToInfo;
	long int Pos;
	unsigned int Size;
	long int Date;
	tMsgStatusFlag Status;
	unsigned int Replies;
	char Subject[41];
	tNetAttribFlag NetFlag;
	unsigned int SigPos;
	unsigned int incFile;
	unsigned int msgTag;

	unsigned char Reserved[54];
} tMsgHeaderRec;

void *pMsgHeaderRec = &tMsgHeaderRec;

typedef struct {
 unsigned int maUnhidden         : 1;
 unsigned int maRealName         : 1;
 unsigned int maPrivate          : 1;
 unsigned int maMandatory        : 1;
 unsigned int maAnonymous        : 1;
} tMsgAreaFlag;

typedef struct {
	char Name[41];
	char Filename[9];
	char MsgPath[41];
	char Sponsor[37];
	tACString Acs;
	tACString postAcs;
	unsigned int MaxMsgs;
	unsigned int Msgs;
	char Password[21];
	tMsgAreaFlag Flag;
	unsigned char AreaType;
	unsigned char Origin;
	unsigned char Address;
	char qwkName[17];

	unsigned char Reserved[83];
} tMsgAreaRec;

char tMessage[maxMsgLines][81];
void *pMessage = &tMessage;

typedef struct {
	char Name[41];
	char SysOp[37];
	char Phone[14];
	long int baud;
	char Software[13];
	char Storage[21];
	char Info[76];
	char WhoAdded[37];
} tBBSlistRec;

typedef struct {
	char Desc[41];
	unsigned char SL;
	unsigned char DSL;
	unsigned int timeLimit;
	unsigned int filePts;
	unsigned int PostCall;
	unsigned int limitDL;
	unsigned int limitDLkb;
	char UserNote[41];
	unsigned int uldlRatio;
	unsigned int kbRatio;

	unsigned char Reserved[196];
} tLevelRec;

tLevelRec tLevels[26];

typedef struct {
 unsigned int protActive : 1;
 unsigned int protBatch  : 1;
 unsigned int protBiDir  : 1;
} tProtFlag;

tProtFlag tProtFlagSet;

typedef struct {
	char Desc[37];
	tProtFlag Flag;
	char Key;
	tACString Acs;
	char Log[26];
	char cmdUL[79];
	char cmdDL[79];
	char cmdEnv[61];
	char codeUL[6][7];
	char codeDL[6][7];
	unsigned char codeIs;
	char ListDL[26];
	unsigned int posFile;
	unsigned int posStat;

	unsigned char Reserved[50];
} tProtRec;

typedef struct {
	long int CallNum;
	char Username[37];
	unsigned int Usernum;
	char Location[41];
	long int Baud;
	char Date[9];
	char Time[8];
	unsigned char NewUser;
	char AreaCode[4];
} tCallRec;

typedef struct {
	char FirstDay[9];
	unsigned int Calls;
	unsigned int Posts;
	unsigned int Email;
	unsigned int Uploads;
	unsigned int Downloads;
	unsigned int UploadKb;
	unsigned int DownloadKb;
} tStatRec;

typedef struct {
	char Date[9];
	unsigned int Calls;
	unsigned int NewUsers;
	unsigned int Posts;
	unsigned int Email;
	unsigned int Uploads;
	unsigned int Downloads;
	unsigned int UploadKb;
	unsigned int DownloadKb;
} tHistoryRec;

typedef struct {
	char Name[41];
	char Filename[9];
	char Path[41];
	char Sponsor[37];
	tACString acs;
	tACString acsUL;
	tACString acsDL;
	char Password[21];
	unsigned int Files;
	unsigned char SortType;
	unsigned char SortAcen;

	unsigned char Reserved[100];
} tFileAreaRec;

typedef struct {
	char Filename[13];
	long int Size;
	char Date[9];
	unsigned int Downloads;
	unsigned int filePts;
	char Uploader[37];
	char ulDate[9];
	long int DescPtr;
	unsigned char DescLns;
	unsigned char Valid;

	unsigned char Reserved[40];
} tFileRec;

typedef struct {
	char UserName[37];
	char RealName[37];
	unsigned char Deleted;
} tUserIndexRec;

typedef struct {
	long int Day;
	long int Hour;
	long int Min;
	long int Sec;
} tDateTimeRec;

typedef struct {
	unsigned char Active;
	char Extension[4];
	char fileSig[21];
	char cmdZip[41];
	char cmdUnZip[41];
	char cmdTest[41];
	char cmdComment[41];
	char cmdDelete[41];
	unsigned char Viewer;
	unsigned char okErrLevel;
	unsigned char CkeckEL;

	unsigned char Reserved[200];
} tArchiverRec;

typedef struct {
	unsigned char Active;
	char Desc[31];
	unsigned char RunMissed;
	unsigned char OffHook;
	unsigned int Node;
	int Time;
} tEventRec;

typedef struct {
	char Desc[31];
	tACString Acs;
	char Key;
} tConfRec;

typedef struct {
	unsigned char Kill;
	char Desc[71];
	char Filename[13];
	char ulDate[9];
	long int Size;
	unsigned char Sent;
	unsigned char Delete;
} tAttachRec;

typedef struct {
	char Filename[9];
} tTextLibRec;

typedef struct {
	char Name[37];
	unsigned char Level;
	unsigned int Lines;
	long int Score;
} tTetrisHiRec;

typedef struct {
	long int Pos;
	unsigned int Size;
} tInfoIdxRec;

typedef struct {
	char Desc[41];
	char Filename[14];
	unsigned char Mand;
	unsigned char Nuv;
	tACString Acs;
} tInfoformRec;

